program sorty;

uses dos, (* gettimeom budeme merat cas sortovania *)
     crt; (* clrscrom budeme mazat obrazovku *)
          (* readkeyom budeme citat tlacicu menua *)

const pocet =  16000; (* pocet prvkov pola *)
      kelo  =      5; (* kelo prvkov vypisat *)
      h_min =      0; (* min hodnota prvku pola *)
      h_max =  32000; (* max hodnota prvku pola *)

type  typ   = integer;
      pole  = array[0..pocet] of typ; (* 0 pre insert sort *)

var   sort  : pole;   (* pole ktore sa bude sortovat *)
      vzor  : pole;   (* neusporiadane pole *)
      menu  : char;   (* vyber sortovania *)
      cas   : real;
      casy  : array[1..2, 1..10] of real; (* casy jedtotlivych sortov *)
      i     : byte;

(* funkcia vrati cislo pre volanie funkcie stopcas *)
(* nevolat tesne pred polnocou *)
function startcas : real; 
var h, m, s, d : word;
begin
  gettime(h,m,s,d);
  startcas:=3600*h+60*m+s+d/100;
end;

(* funkcia vrati cas ubehnuty od volania startcas *)
(* nevolat tesne po polnoci *)
function stopcas(time:real) : real;
var h, m, s, d : word;
begin
  gettime(h,m,s,d);
  stopcas:=(3600*h+60*m+s+d/100)-time;
end;

(* procedura naplni pole nahodnymi cislami *)
procedure naplnpole(var a:pole; n:integer; h_min:typ; h_max:typ);
var i : integer;
begin
  randomize;
  for i:=1 to n do begin
    a[i]:=h_min+random(h_max-h_min+1);
  end;
end;

(* procedura skopiruje prvky pola (b) do pola (a) *)
procedure kopirujpole(var a:pole; b:pole; n:integer);
var i : integer;
begin
  for i:=1 to n do begin
    a[i]:=b[i];
  end;
end;

(* procedura vypise prvych n prvkov pola *)
procedure vypispole(a:pole; n:integer);
var i : integer;
begin
  for i:=1 to n do begin
    write(a[i], ', ');
  end;
  writeln('... ');
end;

(* select sort (od maximalnej hodnoty) *)
procedure selectmax(var a:pole; n:integer);
var i, j, k : integer;
    max     : typ;
begin
  for i:=n downto 2 do begin
    max:=a[i];
    k:=i;
    for j:=i-1 downto 1 do begin
      if a[j]>max then begin
        max:=a[j];
        k:=j;
      end;
    end;
    a[k]:=a[i];
    a[i]:=max;
  end;
end; 

(* select sort (od minimalnej hodnoty) *)
procedure selectmin(var a:pole; n:integer);
var i, j, k : integer;
    min     : typ;
begin
  for i:=1 to n-1 do begin
    min:=a[i];
    k:=i;
    for j:=i+1 to n do begin
      if a[j]<min then begin 
        min:=a[j];
        k:=j;
      end;
    end;
    a[k]:=a[i];
    a[i]:=min;
  end;
end; 

(* bubble sort (neoptimalizovany) *)
procedure bubbleneopt(var a:pole; n:integer);
var i, j  : integer;
    pompo : typ;
begin
  for i:=1 to n do begin
    for j:=2 to n do begin
      if a[j]<a[j-1] then begin
        pompo:=a[j-1];
        a[j-1]:=a[j];
        a[j]:=pompo;
      end;
    end;
  end;
end;

(* bubble sort (nepozna posortovane pole) *)
procedure bubble(var a:pole; n:integer);
var i, j  : integer;
    pompo : typ;
begin
  for i:=n downto 1 do begin
    for j:=2 to i do begin
      if a[j]<a[j-1] then begin
        pompo:=a[j-1];
        a[j-1]:=a[j];
        a[j]:=pompo;
      end;
    end;
  end;
end;

(* bubble sort (pozna posortovane pole) *)
procedure bubblepozna(var a:pole; n:integer);
var i, j, k : integer;
    pompo   : typ;
begin
  k:=n;
  repeat
    j:=1;
    for i:=2 to k do begin
      if a[i]<a[i-1] then begin
        pompo:=a[i-1];
        a[i-1]:=a[i];
        a[i]:=pompo;
        j:=i;
      end;
    end;
    k:=j-1;
  until k=0;
end;

(* shaker sort (striedava bublacka) *)
procedure shaker(var a:pole; n:integer);
var i, j, L, R : integer;
    pompo   : typ;
begin
  L:=2;
  R:=n;
  j:=n;
  repeat
    for i:=R downto L do begin (* zprava dolava *)
      if a[i]<a[i-1] then begin
        pompo:=a[i-1];
        a[i-1]:=a[i];
        a[i]:=pompo;
        j:=i;
      end;
    end;
    L:=j+1;
    for i:=L to R do begin (* zlava doprava *)
      if a[i]<a[i-1] then begin
        pompo:=a[i-1];
        a[i-1]:=a[i];
        a[i]:=pompo;
        j:=i;
      end;
    end;
    R:=j-1;
  until L>R;
end;

(* insert sort (zatriedovanie) *)
procedure insertsort(var a:pole; n:integer);
var i, j  : integer;
    pompo : typ;
begin
  for i:=2 to n do begin
    pompo:=a[i];
    j:=i-1;
    a[0]:=pompo; (* posuvaci nulty prvok pola (zarazka) *)
    while pompo<a[j] do begin
      a[j+1]:=a[j];
      j:=j-1;
    end;
    a[j+1]:=pompo;
  end;
end;

(* binary sort (zatriedovanie dla binarneho vyhladavania) *)
procedure insertbinary(var a:pole; n:integer);
var i, j, k, L, R : integer;
    pompo : typ;
begin
  for i:=2 to n do begin
    pompo:=a[i];
    L:=1;
    R:=i-1;
    while L<=R do begin
      k:=(L+R) div 2;
      if pompo<a[k] then R:=k-1
      else L:=k+1;
    end;
    for j:=i-1 downto L do begin
      a[j+1]:=a[j];
    end;
    a[L]:=pompo;
  end;
end;

(* quick sort (rekurzivne rozdelenie pola) *)
procedure quickreku(var a:pole; LL,RR:integer);
var L, R : integer;
    pompo, x : typ;
begin
  x:=a[(LL+RR) div 2];
  L:=LL;
  R:=RR;
  repeat
    while a[L]<x do L:=L+1;
    while a[R]>x do R:=R-1;
    if L<=R then begin
      pompo:=a[L];
      a[L]:=a[R];
      a[R]:=pompo;
      L:=L+1;
      R:=R-1;
    end;
  until L>R;
  if LL<R then quickreku(a, LL, R);
  if L<RR then quickreku(a, L, RR);
end;

(* procedura zaraddoheapu zaradi prvok do heapbintreeho *)
procedure zaraddoheapu(var a:pole; L, R : integer);
var i, j : integer;
    x    : typ;
    bulo : boolean;
begin
  i:=L;
  j:=2*i; 
  x:=a[i];
  bulo:=(j<=R);
  while bulo do begin
    if j<R then begin 
      if a[j+1]>a[j] then j:=j+1;
    end;
    if x>a[j] then bulo:=false
    else begin
      a[i]:=a[j];
      i:=j;
      j:=2*i;
      bulo:=(j<=R);
    end;
  end;
  a[i]:=x;
end;

(* heap sort (stromova struktura heapa) *)
procedure heapa(var a:pole; n:integer);
var L :integer;
    pompo : typ;
begin
  L:=n div 2;
  for L:=L downto 1 do zaraddoheapu(a, L, n);
  for L:=n downto 2 do begin
    pompo:=a[L];
    a[L]:=a[1];
    a[1]:=pompo;
    zaraddoheapu(a, 1, L-1);
  end;
end;

(* procedura helmuthovemenu vypise helmuthove menu *)
procedure helmuthovemenu;
begin
  clrscr;
  writeln('Sortiada ', pocet, ' prvkoveho pola s nahodnymi integer hodnotami ', h_min, '..',h_max);
  writeln('Pre zmenu hodnot upravte sekciu const zdrojaku a prekompilujte ho. '); 
  write('Nesortovane pole: ');
  vypispole(vzor, kelo);
  writeln('Po vybere z menu sa vykona sortovanie nesortovaneho pola a nasledne repete ');
  writeln('sortovanie uz posortovaneho pola. Pri dalsom vybere z menu sortiady sa ');
  writeln('dvojsortiada vykona na povodnom nesortovanom poli (moznost porovnat casy). ');
  writeln('Cas -99.99s znamena ze prislusnemu sortu este nebolo umoznene prejavit sa. ');  
  writeln;
  writeln('1  Select sort (vyber max) . . . . . . . . . . . . . . . . . ', casy[1,1]:6:2, 's / ', casy[2,1]:6:2, 's ');
  writeln('2  Select sort (vyber min) . . . . . . . . . . . . . . . . . ', casy[1,2]:6:2, 's / ', casy[2,2]:6:2, 's ');
  writeln('3  Bubble sort (neoptimalizovany)  . . . . . . . . . . . . . ', casy[1,3]:6:2, 's / ', casy[2,3]:6:2, 's ');
  writeln('4  Bubble sort (nepozna posortovane pole)  . . . . . . . . . ', casy[1,4]:6:2, 's / ', casy[2,4]:6:2, 's ');
  writeln('5  Bubble sort (pozna posortovane pole)  . . . . . . . . . . ', casy[1,5]:6:2, 's / ', casy[2,5]:6:2, 's ');
  writeln('6  Shaker sort (striedava bublacka)  . . . . . . . . . . . . ', casy[1,6]:6:2, 's / ', casy[2,6]:6:2, 's ');
  writeln('7  Insert sort (zatriedovanie) . . . . . . . . . . . . . . . ', casy[1,7]:6:2, 's / ', casy[2,7]:6:2, 's ');
  writeln('8  Binary sort (zatriedovanie dla binarneho vyhladavania)  . ', casy[1,8]:6:2, 's / ', casy[2,8]:6:2, 's ');
  writeln('9  Quick  sort (rozdelenie pola - rekurzivna realizacia) . . ', casy[1,9]:6:2, 's / ', casy[2,9]:6:2, 's ');
  writeln('a  Heap   sort (stromova struktura heapa)  . . . . . . . . . ', casy[1,10]:6:2, 's / ', casy[2,10]:6:2, 's ');
  writeln;
  writeln('q  ukoncenie sortiady ');
  writeln;
end;

(* procedura vyprazdniklavesovybuffer vyprazdni klavesovy buffer *)
procedure vyprazdniklavesovybuffer;
var vyprazdnovac : char;
begin                                              
  while keypressed do vyprazdnovac:=readkey;
end;

(* procedura helmuthovvyber vybera z helmuthovho menu *)
procedure helmuthovvyber;
begin
  repeat
    vyprazdniklavesovybuffer;
    menu:=readkey;
    case menu of
      '1' : begin (* selectmax *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              selectmax(sort, pocet);
              cas:=stopcas(cas); casy[1,1]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              selectmax(sort, pocet);
              cas:=stopcas(cas); casy[2,1]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '2' : begin (* selectmin *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              selectmin(sort, pocet);
              cas:=stopcas(cas); casy[1,2]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              selectmin(sort, pocet);
              cas:=stopcas(cas); casy[2,2]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '3' : begin (* bubbleneopt *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              bubbleneopt(sort, pocet);
              cas:=stopcas(cas); casy[1,3]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              bubbleneopt(sort, pocet);
              cas:=stopcas(cas); casy[2,3]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '4' : begin (* bubble *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              bubble(sort, pocet);
              cas:=stopcas(cas); casy[1,4]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              bubble(sort, pocet);
              cas:=stopcas(cas); casy[2,4]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '5' : begin (* bubblpozna *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              bubblepozna(sort, pocet);
              cas:=stopcas(cas); casy[1,5]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              bubblepozna(sort, pocet);
              cas:=stopcas(cas); casy[2,5]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '6' : begin (* shaker *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              shaker(sort, pocet);
              cas:=stopcas(cas); casy[1,6]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              shaker(sort, pocet);
              cas:=stopcas(cas); casy[2,6]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '7' : begin (* insertsort *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              insertsort(sort, pocet);
              cas:=stopcas(cas); casy[1,7]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              insertsort(sort, pocet);
              cas:=stopcas(cas); casy[2,7]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '8' : begin (* insertbinary *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              insertbinary(sort, pocet);
              cas:=stopcas(cas); casy[1,8]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              insertbinary(sort, pocet);
              cas:=stopcas(cas); casy[2,8]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      '9' : begin (* quickreku *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              quickreku(sort, 1, pocet);
              cas:=stopcas(cas); casy[1,9]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              quickreku(sort, 1, pocet);
              cas:=stopcas(cas); casy[2,9]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
      'a' : begin (* heapa *)
              write('C. sortu: ', menu, ' .. ');
              kopirujpole(sort, vzor, pocet);
              cas:=startcas;
              heapa(sort, pocet);
              cas:=stopcas(cas); casy[1,10]:=cas;
              write('Cas sortu: ', cas:6:2, ' s. ');
              write('Sortovane pole: ');
              vypispole(sort, kelo);
              (* a co tak usporiadat usporiadane *)
              cas:=startcas;
              write('               repete:    ');
              heapa(sort, pocet);
              cas:=stopcas(cas); casy[2,10]:=cas;
              write(cas:6:2, ' s. '); write('Momentik ... '); cas:=startcas; while stopcas(cas)<2 do begin end;
              helmuthovemenu;
            end;
    end;
  until (ord(menu)=27) or (menu='q');
end;

begin
  {$M 65520, 0, 655360} (* ach ta moja pamat *)
  for i:=1 to 10 do begin
    casy[1,i]:=-99.99;
    casy[2,i]:=-99.99;
  end;
  naplnpole(vzor, pocet, h_min, h_max);
  helmuthovemenu;
  helmuthovvyber;
  writeln('Dosortovania priatelia!');
end.